import { Base, Type, INotifyPropertyChanged, PropertyChangedEventArgs } from "igniteui-react-core";
import { DomRenderer, DomWrapper } from "igniteui-react-core";
import { AnimationKeyFrameEffect } from "igniteui-react-core";
import { AnimationKeyFrameEffectTiming } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { PopupAlignment } from "./PopupAlignment";
import { PopupDirection } from "./PopupDirection";
import { Brush } from "igniteui-react-core";
import { OnClosedEventArgs } from "./OnClosedEventArgs";
import { OnPopupEventArgs } from "./OnPopupEventArgs";
/**
 * @hidden
 */
export declare class PopupView extends Base {
    static $t: Type;
    private i;
    private c;
    private m;
    private l;
    private k;
    private p;
    private f;
    protected readonly d: Popup;
    protected readonly j: DomRenderer;
    protected x(): void;
    ab(): void;
    ac(): void;
    q(): void;
    z(): void;
    r(a: any): void;
    a(a: AnimationKeyFrameEffectTiming): AnimationKeyFrameEffect;
    b(a: AnimationKeyFrameEffectTiming): AnimationKeyFrameEffect;
    s(): void;
    n(): number;
    o(): number;
    private g;
    private h;
    ad(a: Rect, b: PopupDirection, c: PopupAlignment): Rect;
    private aa;
    y(a: DomRenderer): void;
    protected t(a: DomWrapper): void;
    u(a: Popup): void;
    private e;
    v(): void;
    w(): void;
}
/**
 * @hidden
 */
export declare class Popup extends Base implements INotifyPropertyChanged {
    static $t: Type;
    private f;
    private e;
    private ay;
    private k;
    private l;
    constructor();
    onClosed: (sender: any, args: OnClosedEventArgs) => void;
    onPopup: (sender: any, args: OnPopupEventArgs) => void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    protected ai(a: string, b: any, c: any): void;
    h: PopupView;
    private q;
    t: number;
    private static s;
    private p;
    r: number;
    private n;
    readonly o: boolean;
    private static ax;
    private ar;
    au: Brush;
    private static aw;
    private aq;
    at: Brush;
    private static av;
    private ap;
    as: Brush;
    protected g(): PopupView;
    protected ak(a: string, b: any, c: any): void;
    private ab;
    private i;
    private j;
    private a;
    private b;
    private ae;
    private m;
    af(): void;
    private aj;
    private am;
    private an;
    appendPopupContent(a: any): void;
    ac(): void;
    destroy(): void;
    showRelativeToExclusionRect(a: Rect, b: PopupDirection, c: PopupAlignment): void;
    ag(a: Rect): void;
    notifySizeChanged(): void;
    provideRenderer(a: DomRenderer): void;
}
