/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, markType, INotifyPropertyChanged_$type, PropertyChangedEventArgs } from "igniteui-react-core";
import { ElevationHelper } from "igniteui-react-core";
import { AnimationKeyFrameEffect } from "igniteui-react-core";
import { AnimationKeyFrameEffectTiming } from "igniteui-react-core";
import { KeyFrameAnimationFactory } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { stringFormat } from "igniteui-react-core";
import { stringEmpty } from "igniteui-react-core";
import { OnClosedEventArgs } from "./OnClosedEventArgs";
import { List$1 } from "igniteui-react-core";
import { AnimationKeyFrameProperty } from "igniteui-react-core";
import { TranslateTransform } from "igniteui-react-core";
import { OnPopupEventArgs } from "./OnPopupEventArgs";
import { BrushUtil } from "igniteui-react-core";
/**
 * @hidden
 */
export let PopupView = /*@__PURE__*/ (() => {
    class PopupView extends Base {
        constructor() {
            super(...arguments);
            this.i = null;
            this.c = null;
            this.m = null;
            this.l = null;
            this.k = null;
            this.p = null;
            this.f = false;
            this.e = true;
        }
        get d() {
            return this.c;
        }
        get j() {
            return this.i;
        }
        x() {
            this.m.setStyleProperty("height", "0%");
            this.m.setStyleProperty("width", "0%");
            this.l = this.i.createElement("div");
            this.l.setStyleProperty("position", "absolute");
            this.l.setStyleProperty("overflow", "hidden");
            this.l.setStyleProperty("z-index", "10000");
            this.l.setAttribute("key", "popupContentAreaOuter");
            this.k = this.i.createElement("div");
            this.k.setAttribute("key", "popupContentAreaInner");
            this.l.append(this.k);
        }
        ab() {
            let a = this.d;
            let b = ElevationHelper.e(a.r, a.au, a.at, a.as);
            this.l.setStyleProperty("box-shadow", b);
        }
        ac() {
            if (null == this.m) {
                return;
            }
            this.ab();
        }
        q() {
            if (null != this.l) {
                this.ac();
                this.l.setStyleProperty("height", "0px");
                let a = this.l.getNativeElement();
                if (false == this.f) {
                    document.body.appendChild(a);
                    this.f = true;
                    if (this.e) {
                        this.v();
                    }
                }
            }
        }
        z() {
            if (null != this.l && this.f) {
                let a = this.l.getNativeElement();
                document.body.removeChild(a);
                this.f = false;
            }
        }
        r(a) {
            this.k.append(a);
        }
        a(a) {
            return new AnimationKeyFrameEffect(0, this.k, 0, null, a);
        }
        b(a) {
            return new AnimationKeyFrameEffect(0, this.l, 0, null, a);
        }
        s() {
            if (KeyFrameAnimationFactory.h == null) {
                KeyFrameAnimationFactory.h = this.j;
            }
        }
        n() {
            return this.k.outerHeight();
        }
        o() {
            return this.k.outerWidth();
        }
        g(a, b) {
            let c;
            let t1 = b;
            L0: while (true) {
                switch (t1) {
                    case 0:
                    case 1:
                        c = a.left;
                        break;
                    case 2:
                        c = a.right - this.o();
                        break;
                    default:
                        t1 = 0;
                        continue L0;
                }
                break;
            }
            return c;
        }
        h(a, b) {
            let c;
            let t1 = b;
            L0: while (true) {
                switch (t1) {
                    case 0:
                    case 1:
                        c = a.bottom;
                        break;
                    case 2:
                        c = a.top - this.n();
                        break;
                    default:
                        t1 = 0;
                        continue L0;
                }
                break;
            }
            return c;
        }
        ad(a, b, c) {
            let d = this.h(a, b);
            let e = this.g(a, c);
            this.aa(e, d);
            if (b == 2 || c == 2) {
                let f = 10;
                while (f > 0) {
                    let g = this.h(a, b);
                    let h = this.g(a, c);
                    if (g == d && h == e) {
                        f = 0;
                        break;
                    }
                    d = g;
                    e = h;
                    this.aa(e, d);
                    f--;
                }
            }
            return new Rect(0, e, d, this.o(), this.n());
        }
        aa(a, b) {
            let c = stringFormat("{0}px", a);
            let d = stringFormat("{0}px", b);
            this.l.setStyleProperty("left", c);
            this.l.setStyleProperty("top", d);
        }
        y(a) {
            if (a == null) {
                this.i = null;
                return;
            }
            this.i = a;
            let b = a.rootWrapper;
            this.t(b);
            this.i.getPortal(this.k, "ChildContent", (c) => {
                let comp_ = c.componentRef;
                this.p = comp_;
            }, true);
        }
        t(a) {
            this.m = a;
            this.x();
        }
        u(a) {
            this.c = a;
        }
        v() {
            if (this.f) {
                this.l.setStyleProperty("width", stringEmpty());
                this.l.setStyleProperty("height", stringEmpty());
                let a = this.o();
                let b = this.n();
                let c = stringFormat("{0}px", a);
                let d = stringFormat("{0}px", b);
                this.l.setStyleProperty("width", c);
                this.l.setStyleProperty("height", d);
                this.e = false;
            }
            else {
                this.e = true;
            }
        }
        w() {
        }
    }
    PopupView.$t = /*@__PURE__*/ markType(PopupView, 'PopupView');
    return PopupView;
})();
/**
 * @hidden
 */
export let Popup = /*@__PURE__*/ (() => {
    class Popup extends Base {
        constructor() {
            super();
            this.f = 0;
            this.e = 0;
            this.ay = null;
            this.k = null;
            this.l = null;
            this.onClosed = null;
            this.onPopup = null;
            this.propertyChanged = null;
            this.h = null;
            this.q = -1;
            this.p = Popup.s;
            this.n = false;
            this.ar = Popup.ax;
            this.aq = Popup.aw;
            this.ap = Popup.av;
            let a = this.g();
            this.h = a;
            a.u(this);
        }
        ai(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.ak(a, b, c);
        }
        get t() {
            return this.q;
        }
        set t(a) {
            let b = this.q;
            this.q = a;
            if (b != this.q) {
                this.ai("Elevation", b, a);
            }
        }
        get r() {
            return this.p;
        }
        set r(a) {
            let b = this.p;
            this.p = a;
            if (b != this.p) {
                this.ai("ActualElevation", b, a);
            }
        }
        get o() {
            return this.n;
        }
        get au() {
            return this.ar;
        }
        set au(a) {
            let b = this.ar;
            this.ar = a;
            if (b != this.ar) {
                this.ai("ActualUmbraShadowColor", b, a);
            }
        }
        get at() {
            return this.aq;
        }
        set at(a) {
            let b = this.aq;
            this.aq = a;
            if (b != this.aq) {
                this.ai("ActualPenumbraShadowColor", b, a);
            }
        }
        get as() {
            return this.ap;
        }
        set as(a) {
            let b = this.ap;
            this.ap = a;
            if (b != this.ap) {
                this.ai("ActualAmbientShadowColor", b, a);
            }
        }
        g() {
            return new PopupView();
        }
        ak(a, b, c) {
            switch (a) {
                case "IsShown":
                    if (false == this.o) {
                        this.h.z();
                    }
                    break;
                case "Elevation":
                    this.r = this.t == -1 ? Popup.s : this.t;
                    break;
                case "ActualElevation":
                case "ActualUmbraShadowColor":
                case "ActualPenumbraShadowColor":
                case "ActualAmbientShadowColor":
                    this.h.ac();
                    break;
            }
        }
        ab() {
            if (this.m()) {
                if (null != this.l && this.l.playState == 1) {
                    this.l.cancel();
                }
                if (null != this.k && this.k.playState == 1) {
                    this.k.cancel();
                }
            }
        }
        i(a) {
            let b = this.h.n();
            if (b <= 0) {
                b = 500;
            }
            let c = a ? -b : 0;
            let d = a ? 0 : -b;
            if (this.f == 2) {
                c = 0;
                d = 0;
            }
            let e = a ? 0 : 1;
            let f = a ? 1 : 0;
            let g = a ? this.b() : this.a();
            let h = this.h.a(g);
            let i = new List$1(AnimationKeyFrameProperty.$, 0);
            let j = new List$1(AnimationKeyFrameProperty.$, 0);
            let k = new TranslateTransform();
            k.k = c;
            let l = new TranslateTransform();
            l.k = d;
            let m = new AnimationKeyFrameProperty(14, k);
            let n = new AnimationKeyFrameProperty(14, l);
            i.add(m);
            j.add(n);
            let o = new AnimationKeyFrameProperty(1, e);
            let p = new AnimationKeyFrameProperty(1, f);
            i.add(o);
            j.add(p);
            h.m(...i.toArray());
            h.m(...j.toArray());
            return KeyFrameAnimationFactory.f.c(h);
        }
        j(a) {
            let b = this.h.n();
            if (b <= 0) {
                b = 500;
            }
            let c = a ? 0 : b;
            let d = a ? b : 0;
            let e = a ? this.b() : this.a();
            let f = this.h.b(e);
            let g = new List$1(AnimationKeyFrameProperty.$, 0);
            let h = new List$1(AnimationKeyFrameProperty.$, 0);
            let i = new AnimationKeyFrameProperty(10, c);
            let j = new AnimationKeyFrameProperty(10, d);
            g.add(i);
            h.add(j);
            if (this.f == 2) {
                let k = a ? this.ay.bottom : this.ay.top;
                let l = a ? this.ay.top : this.ay.bottom;
                let m = new AnimationKeyFrameProperty(12, k);
                let n = new AnimationKeyFrameProperty(12, l);
                g.add(m);
                h.add(n);
            }
            f.m(...g.toArray());
            f.m(...h.toArray());
            return KeyFrameAnimationFactory.f.c(f);
        }
        a() {
            let a = new AnimationKeyFrameEffectTiming();
            a.g = 300;
            a.b = 3;
            return a;
        }
        b() {
            let a = new AnimationKeyFrameEffectTiming();
            a.g = 300;
            a.b = 3;
            return a;
        }
        ae() {
            this.h.s();
        }
        m() {
            if (null == this.l && null == this.k) {
                return false;
            }
            if (null != this.l && this.l.playState == 1) {
                return true;
            }
            if (null != this.k && this.k.playState == 1) {
                return true;
            }
            return false;
        }
        af() {
            this.h.v();
        }
        aj(a, b, c) {
            this.ay = this.h.ad(a, b, c);
            this.f = b;
            this.e = c;
        }
        am(a, b, c) {
            if (this.n) {
                this.n = false;
                this.ai("IsShown", true, this.n);
            }
            this.h.q();
            this.aj(a, b, c);
            this.an(true);
        }
        an(a) {
            this.ab();
            this.ae();
            let b = this.n;
            this.n = a;
            this.k = this.i(this.n);
            this.l = this.j(this.n);
            this.k.play();
            this.l.play();
            this.k.finished.f((c) => this.k.commitStyles());
            this.l.finished.f((c) => {
                this.l.commitStyles();
                this.ai("IsShown", b, this.n);
                if (this.n) {
                    if (this.onPopup != null) {
                        this.onPopup(this, new OnPopupEventArgs());
                    }
                }
                else {
                    if (this.onClosed != null) {
                        this.onClosed(this, new OnClosedEventArgs());
                    }
                }
            });
        }
        appendPopupContent(a) {
            this.h.r(a);
        }
        ac() {
            if (!this.n) {
                return;
            }
            this.an(false);
        }
        destroy() {
            this.provideRenderer(null);
        }
        showRelativeToExclusionRect(a, b, c) {
            this.am(a, b, c);
        }
        ag(a) {
            this.ay = this.h.ad(a, this.f, this.e);
        }
        notifySizeChanged() {
        }
        provideRenderer(a) {
            this.h.y(a);
        }
    }
    Popup.$t = /*@__PURE__*/ markType(Popup, 'Popup', Base.$, [INotifyPropertyChanged_$type]);
    Popup.s = 2;
    Popup.ax = /*@__PURE__*/ BrushUtil.g(66, 0, 0, 0);
    Popup.aw = /*@__PURE__*/ BrushUtil.g(30, 0, 0, 0);
    Popup.av = /*@__PURE__*/ BrushUtil.g(20, 0, 0, 0);
    return Popup;
})();
//# sourceMappingURL=PopupView_combined.js.map
